﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ATH
{
    public class Entity
    {
        private int id;
        private string name;
        private bool classified;
        public float RowSim { get; set; }
        private float[] attributes;
        
        private static int entityCount = 0;
        
        public Entity(string[] attributes)
        {
            this.id = Entity.entityCount++;
            this.name = attributes[0];
            this.attributes = new float[attributes.Length - 1];
            for (int i = 1; i < attributes.Length; i++)
            {
                this.attributes[i - 1] = Config.FixDecSeparator(attributes[i]);
            }
        }
        public static Entity Create(string[] line)
        {
            return new Entity(line);
        }

        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append(this.Name).Append(Config.CSV_SEPARATOR).Append(AttributesToString());
            return sb.ToString();
        }

        private string AttributesToString()
        {
            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < this.attributes.Length; i++)
            {
                sb.Append(this.attributes[i]).Append(Config.CSV_SEPARATOR);
            }
            sb.AppendLine();
            return sb.ToString();
        }
        public string BasicCsvString()
        {
            return String.Format("{0}{1}{2}", name, Config.CSV_SEPARATOR, this.AttributesToString());
        }

        public string Name
        {
            get { return name; }
        }

        public float[] Attributes
        {
            get { return attributes; }
        }
        public bool Classified
        {
            get { return classified; }
            set { classified = value; }
        }
        public int Id
        {
            get { return id; }
        }
    }
}
