﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ATH
{
    public class SimSpaceHelper
    {
        /*
        public static float GetSimValue(Entity e1, Entity e2)
        {
            float result = 1;
            if (!e1.Equals(e2))
            {
                float up = 0;
                float down = 0;
                for (int i = 0; i < e1.Attributes.Length; i++)
                {
                    up += Math.Min(e1.Attributes[i], e2.Attributes[i]);
                    down += Math.Max(e1.Attributes[i], e2.Attributes[i]);
                }

                result = (down != 0) ? ((float)Math.Round(up / down, Config.DECIMAL_PRECISION)) : 0;
            }
            return result;
        }
        */
        public static float GetWeightedSimValue(Entity e1, Entity e2)
        {
            try
            {
                float mins = e1.Attributes.Select((t, i) => Math.Min(t, e2.Attributes[i])).Sum();
                float maxes = e1.Attributes.Select((t, i) => Math.Max(t, e2.Attributes[i])).Sum();
                return mins / maxes;
            }
            catch 
            {
                return 0;
            }
            /*if (!e1.Equals(e2))
            {
                
                float val = 0;
                for (int i = 0; i < e1.Attributes.Length; i++)
                {

                    
                    if (e2.Attributes[i] != 0 && e1.Attributes[i] > e2.Attributes[i])
                    {
                        val += (e1.Attributes[i] / e2.Attributes[i]);
                    }
                    else if (e1.Attributes[i] != 0 && e1.Attributes[i] <= e2.Attributes[i])
                    {
                        val += (e2.Attributes[i] / e1.Attributes[i]);
                    }
                }

                float n = 1 / e1.Attributes.Length;
                result = (float)Math.Round((n * val), Config.DECIMAL_PRECISION);
            }
            return result;*/
        }
        public string GetAttributeNames()
        {
            return Config.CSV_SEPARATOR + DataCSVHandler.Header;
        }
        /*
        public void ToPairsCSV(string simMatrixPath, List<Entity> entities)
        {
            StringBuilder sb = new StringBuilder(50000);
            int sumInM = (int)Math.Ceiling((double)(entities.Count * entities.Count / 1000000));
            for (int i = 0; i < entities.Count; i++)
            {
                foreach (MinimalEntity m in simMatrix[i].Row)
                {
                    sb.Append(this.entities[i].Id).Append(FileOperation.SEPARATOR).Append(this.entities[i].Name).Append(FileOperation.SEPARATOR).Append(m.Id).Append(FileOperation.SEPARATOR).Append(m.Name).Append(FileOperation.SEPARATOR).Append(m.SimValue);
                    sb.AppendLine();
                }
                FileOperation.AppenText(sb.ToString(), simMatrixPath);
                sb.Clear();
                if (i % 100 == 0) Console.CursorLeft = 0; Console.Write(i + "M lines (from " + sumInM + "M) dumped to file.");
            }
            Console.WriteLine();
        }
        */
        public static void WritePercentageDone(double p)
        {
            p = Math.Round(p * 100, 2);
            string estimated = "";
            string elapsed = "";
            if(p > 0)
            {
                estimated = "Estimated time: " + (new TimeSpan((long)((100 / p) * Stopper.GetElapsedTime().Ticks))).ToString(@"hh\:mm\:ss");
                elapsed = "Elapsed time: " + Stopper.GetElapsedTime().ToString(@"hh\:mm\:ss");
            }
            string percentage = p + "%";
            if (Config.DUMP_MATRIX) Console.Write(percentage + " ");
            Console.Write(estimated + " " + elapsed + "    ");
            Console.CursorLeft = 0;
            if (p == 100) 
            {
                Console.Write("                                                       ");
                Console.CursorLeft = 0;
            }
        }
    }
}
